/*
 * The MIT License (MIT)

Copyright (c) 2013 Empscraft.com / GorillaFresh

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package com.empscraft.bouncer;

import org.bukkit.Bukkit;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.plugin.java.JavaPlugin;

import com.empscraft.bouncer.util.mysql.MySQLDatabaseConfiguration;
import com.empscraft.bouncer.util.mysql.ThreadedSQL;

public class Bouncer extends JavaPlugin {
	
	public void onEnable() {
		instance = this;
		ConfigurationSection cs = getConfig().getConfigurationSection("bouncer");
		
		maxAttempts = cs.getInt("max-failed-logins");
		lockOutTime = cs.getInt("lockout-time");
		forumSoftware = cs.getString("forum-software");
		
		connectDb();
		
		playerAssistant = new PlayerAssistant();
		bouncerListener = new BouncerListener();
		
		getServer().getPluginManager().registerEvents(bouncerListener, this);
		getCommand("register").setExecutor(new CommandAssistant());
		getCommand("verify").setExecutor(new CommandAssistant());
		getCommand("changepw").setExecutor(new CommandAssistant());
		if(Bukkit.getOnlinePlayers().length > 0) {
			playerAssistant.sessionManager.reloadPlayerSessions();
			playerAssistant.sessionManager.antiBrute.resetAllAttempts();
		}
	}
	
	public void onDisable() {
		
	}
	
	public static Bouncer getSingleton() {
		return instance;
	}
	
	public static Bouncer instance;
	public PlayerAssistant playerAssistant;
	public BouncerListener bouncerListener;
	
	public void connectDb() {
		ConfigurationSection cs = getConfig().getConfigurationSection("mysql");
		tablePrefix = cs.getString("table-prefix");
		if(tablePrefix.equalsIgnoreCase("none"))
				tablePrefix = "";
		
		MySQLDatabaseConfiguration config = new MySQLDatabaseConfiguration();
		config.setHost(cs.getString("host"));
		config.setPort(cs.getInt("port"));
		config.setUsername(cs.getString("username"));
		config.setPassword(cs.getString("password"));
		config.setDatabase(cs.getString("database"));
		
		mysql = new ThreadedSQL(config, 2);
	}
	
	public static ThreadedSQL mysql;
	
	public static String tablePrefix;
	public static int maxAttempts;
	public static int lockOutTime;
	public static String forumSoftware;

}
