/*
 * The MIT License (MIT)

Copyright (c) 2013 Empscraft.com / GorillaFresh

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/


package com.empscraft.bouncer;

import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.command.ConsoleCommandSender;
import org.bukkit.command.RemoteConsoleCommandSender;
import org.bukkit.entity.Player;

import com.empscraft.bouncer.util.CommandLineTokenizer;

public class CommandAssistant implements CommandExecutor {

	public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
		if (sender instanceof Player || sender instanceof ConsoleCommandSender || sender instanceof RemoteConsoleCommandSender) {
			if (args.length < 1)
				return false;
			if(sender instanceof Player) {
				args = CommandLineTokenizer.tokenize(args);
			
				if(command.getName().equalsIgnoreCase("register")) {
					Bouncer.getSingleton().playerAssistant.sessionManager.authAdaptor.register((Player)sender, args);
				} else if(command.getName().equalsIgnoreCase("verify")) {
					Player p = (Player) sender;
					p = Bouncer.getSingleton().playerAssistant.sessionManager.getTruePlayerObject(p);
					if(!Bouncer.getSingleton().playerAssistant.sessionManager.antiBrute.isLockedOut(p.getAddress().getHostName())) {
						if(Bouncer.getSingleton().playerAssistant.sessionManager.authAdaptor.passwordMatches(args[0], p.getName())) {
							Bouncer.getSingleton().playerAssistant.sessionManager.setVerified(p);
							Bouncer.getSingleton().playerAssistant.sessionManager.antiBrute.resetAttempt(p.getAddress().getHostName());
							Bouncer.getSingleton().playerAssistant.verifiedMessage(p);
						} else {
							Bouncer.getSingleton().playerAssistant.wrongPasswordMessage(p);
							Bouncer.getSingleton().playerAssistant.sessionManager.antiBrute.addAttempt(p.getAddress().getHostName());
						}
					} else {
						Bouncer.getSingleton().playerAssistant.sessionManager.antiBrute.lockOut(p.getAddress().getHostName());
						p.kickPlayer("Too many invalid verification attempts.");
					}
				} else if(command.getName().equalsIgnoreCase("changepw")) {
					Bouncer.getSingleton().playerAssistant.changePasswordMessage((Player) sender);
				}
				return true;
			}
		}
		return false;
	}

}
