/*
 * The MIT License (MIT)

Copyright (c) 2013 Empscraft.com / GorillaFresh

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package com.empscraft.bouncer;

import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.entity.Player;

import com.empscraft.bouncer.auth.SessionAssistant;


public class PlayerAssistant {
	
	public PlayerAssistant() {
		sessionManager = new SessionAssistant();
		sessionManager.setAuthAdaptor(Bouncer.forumSoftware);
	}
	
	public SessionAssistant sessionManager;
	
	
	
	public void cantMessage(Player p) {
		p.sendMessage(notVerified);
	}
	
	public void verifiedMessage(Player p) {
		p.sendMessage(nowVerified);
	}
	
	public void changePasswordMessage(Player p) {
		p.sendMessage(changePassword);
	}
	
	public void wrongPasswordMessage(Player p) {
		p.sendMessage(invalidPassword);
	}
	
	public void lockedOutMessage(Player p) {
		p.sendMessage(lockout);
	}
	
	public void lockedOutKickMessage(Player p) {
		p.sendMessage(lockoutKick);
	}
	
	public ConfigurationSection cs = Bouncer.getSingleton().getConfig().getConfigurationSection("messages");
	public String notVerified = cs.getString("not-verified");
	public String nowVerified = cs.getString("now-verified");
	public String lockoutKick = cs.getString("lockout-kick");
	public String lockout = cs.getString("lockout");
	public String invalidPassword = cs.getString("invalid-password");
	public String changePassword = cs.getString("change-password");
	
}
