/*
 * The MIT License (MIT)

Copyright (c) 2013 Empscraft.com / GorillaFresh

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package com.empscraft.bouncer.auth;

import java.util.HashMap;
import java.util.Map;

import org.bukkit.Bukkit;
import org.bukkit.entity.Player;

import com.empscraft.bouncer.Bouncer;
import com.empscraft.bouncer.auth.forum.FluxBB;
import com.empscraft.bouncer.model.AuthAdaptor;
import com.empscraft.bouncer.model.Session;
import com.empscraft.bouncer.model.Session.State;
import com.empscraft.bouncer.util.AntiBrute;


public class SessionAssistant {
	
	public SessionAssistant() {
		
	}
	
	public void setAuthAdaptor(String name) {
		if(name.toLowerCase().equals("fluxbb"))
			authAdaptor = new FluxBB();
	}
	
	public AuthAdaptor authAdaptor = null;
	public AntiBrute antiBrute = new AntiBrute();
	
	public boolean isVerified(Player p) {
		p = getTruePlayerObject(p);
		try {
			return playerSession.get(p).status == Session.State.Verified;
		} catch(Exception e) {
			return false;
		}
	}
	
	public boolean addSession(Player p, Session sesh) {
		
		if(!sessionExists(p)) {
			playerSession.put(p, sesh);
			return true;
		} else
			return false;
	}
	
	public boolean sessionExists(Player p) {
		return playerSession.containsKey(p);
	}
	
	public Session getSession(Player p) {
		Player plr = Bukkit.getServer().getPlayer(p.getName());
		if(sessionExists(plr)) {
			return playerSession.get(plr);
		}
		return null;
	}
	
	public Player getTruePlayerObject(Player p) {
		return Bukkit.getServer().getPlayer(p.getName());
	}
	
	public void setVerified(Player p) {
		Session sesh = getSession(getTruePlayerObject(p));
		sesh.status = State.Verified;
		playerSession.remove(p);
		playerSession.put(p, sesh);
	}
	
	public void reloadPlayerSessions() {
		Player[] players = Bukkit.getOnlinePlayers();
		Bouncer.getSingleton().playerAssistant.sessionManager.playerSession.clear();
		
		for(Player plr : players) {
			System.out.println(plr.getName());
			Player p = Bouncer.getSingleton().playerAssistant.sessionManager.getTruePlayerObject(plr);
			if(!Bouncer.getSingleton().playerAssistant.sessionManager.sessionExists(p)) {
				Session session = new Session(p);
				if(Bouncer.getSingleton().playerAssistant.sessionManager.authAdaptor.usernameExists(p.getName())) {
					session.status = Session.State.Registered;
				} else {
					session.status = Session.State.Guest;
				}
				Bouncer.getSingleton().playerAssistant.sessionManager.addSession(p, session);
			} else {
				Bouncer.getSingleton().playerAssistant.sessionManager.playerSession.remove(p);
			}
		}
	}
	
	public Map<Player, Session> playerSession = new HashMap<Player, Session>();

}
