/*
 * The MIT License (MIT)

Copyright (c) 2013 Empscraft.com / GorillaFresh

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package com.empscraft.bouncer.auth.forum;

import java.sql.PreparedStatement;
import java.sql.ResultSet;

import org.bukkit.entity.Player;

import com.empscraft.bouncer.Bouncer;
import com.empscraft.bouncer.auth.hash.SHA1;
import com.empscraft.bouncer.model.AuthAdaptor;

public class FluxBB extends AuthAdaptor {

	public FluxBB() {
		hash = new SHA1();
		setForumStyle();
	}

	public String getPasswordHash(String username) {
		try {
			PreparedStatement prep = Bouncer.mysql.prepareStatement("SELECT password FROM "+Bouncer.tablePrefix+"users WHERE username = ?");
			prep.setString(1, username);
			ResultSet rs = prep.executeQuery();
			
			if(rs.first()) {
				return rs.getString("password");
			} else {
				return null;
			}
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	public String computePasswordHash(String s) {
		return hash.compute(s);
	}

	public void register(Player p, String args[]) {
		if(usernameExists(p.getName())) {
			p.sendMessage("This account is already registered");
			return;
		}
		try {
			if(args.length == 2) {
				PreparedStatement prep = Bouncer.mysql.prepareStatement("INSERT INTO "+Bouncer.tablePrefix+"users (id, group_id, username, password, email, title, realname, url, jabber, icq, msn, aim, yahoo, location, signature, disp_topics, disp_posts, email_setting, notify_with_post, auto_notify, show_smilies, show_img, show_img_sig, show_avatars, show_sig, timezone, dst, time_format, date_format, language, style, num_posts, last_post, last_search, last_email_sent, last_report_sent, registered, registration_ip, last_visit, admin_note, activate_string, activate_key)  VALUES (NULL, 3, ?, ?, ?, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'English', ?, 0, NULL, NULL, NULL, NULL, 0, ?, 0, NULL, NULL, NULL)");
				prep.setString(1, p.getName());
				prep.setString(2, Bouncer.getSingleton().playerAssistant.sessionManager.authAdaptor.computePasswordHash(args[0]));
				prep.setString(3, args[1]);
				prep.setString(4, forumStyle);
				prep.setString(5, p.getAddress().getHostName());
				prep.executeUpdate();
				p.sendMessage("Your account is registered with the password: "+args[0]);
			} else if(args.length == 1){
				PreparedStatement prep = Bouncer.mysql.prepareStatement("INSERT INTO "+Bouncer.tablePrefix+"users (id, group_id, username, password, email, title, realname, url, jabber, icq, msn, aim, yahoo, location, signature, disp_topics, disp_posts, email_setting, notify_with_post, auto_notify, show_smilies, show_img, show_img_sig, show_avatars, show_sig, timezone, dst, time_format, date_format, language, style, num_posts, last_post, last_search, last_email_sent, last_report_sent, registered, registration_ip, last_visit, admin_note, activate_string, activate_key)  VALUES (NULL, 3, ?, ?, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 'English', ?, 0, NULL, NULL, NULL, NULL, 0, ?, 0, NULL, NULL, NULL)");
				prep.setString(1, p.getName());
				prep.setString(2, Bouncer.getSingleton().playerAssistant.sessionManager.authAdaptor.computePasswordHash(args[0]));
				prep.setString(3, forumStyle);
				prep.setString(4, p.getAddress().getHostName());
				prep.executeUpdate();
				p.sendMessage("Your account is registered with the password: "+args[0]);
			}
		} catch (Exception e) {
			e.printStackTrace();
			
		}
	}

	public boolean usernameExists(String username) {
		try {
			PreparedStatement prep = Bouncer.mysql.prepareStatement("SELECT username FROM "+Bouncer.tablePrefix+"users WHERE username = ?");
			prep.setString(1, username);
			ResultSet rs = prep.executeQuery();
			if(rs.first()) {
				return rs.getString("username").toLowerCase().equals(username.toLowerCase());
			} else {
				return false;
			}
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
	}
	
	public String forumStyle = "Lithium";
	
	public void setForumStyle() {
		try {
			PreparedStatement prep = Bouncer.mysql.prepareStatement("SELECT conf_value FROM "+Bouncer.tablePrefix+"config WHERE conf_name = ?");
			prep.setString(1, "o_default_style");
			ResultSet rs = prep.executeQuery();
			if(rs.first())
				forumStyle = rs.getString("conf_value");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
