/*
 * The MIT License (MIT)

Copyright (c) 2013 Empscraft.com / GorillaFresh

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package com.empscraft.bouncer.util;

import java.util.HashMap;
import java.util.Map;

import com.empscraft.bouncer.Bouncer;

public class AntiBrute {
	
	public AntiBrute() {
		ipLogs = new HashMap<String, IpLog>();
	}
	
	public Map<String, IpLog> ipLogs;
	public static int maxAttempts = 1;
	
	
	public void addAttempt(String ip) {
		if(ipLogs.containsKey(ip)) {
			IpLog ipLog = ipLogs.get(ip);
			ipLog.attempts++;
			ipLogs.remove(ip);
			ipLogs.put(ip, ipLog);
		} else {
			IpLog ipLog = new IpLog();
			ipLog.ip = ip;
			ipLog.attempts++;
			ipLogs.put(ip, ipLog);
		}
	}
	
	public void resetAttempt(String ip) {
		if(ipLogs.containsKey(ip))
			ipLogs.remove(ip);
		if(lockedOut.containsKey(ip))
			lockedOut.remove(ip);
	}
	
	public void resetAllAttempts() {
		ipLogs.clear();
	}
	
	public boolean isLockedOut(String ip) {
		return lockedOut.containsKey(ip);
	}
	
	public boolean isExpired(String ip) {
		if(lockedOut.containsKey(ip))
			return lockedOut.get(ip).expired();
		return false;
	}
	
	public void lockOut(String ip) {
		Bouncer.getSingleton();
		MillisTimer mt = new MillisTimer((60 * Bouncer.lockOutTime));
		lockedOut.put(ip, mt);
	}
	
	public Map<String, MillisTimer> lockedOut = new HashMap<String, MillisTimer>();
}

class IpLog {
	
	public String ip;
	public int attempts = 0;
	
}
