/*
 * The MIT License (MIT)

Copyright (c) 2013 Empscraft.com / GorillaFresh

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package com.empscraft.bouncer.util;

public class MillisTimer {
	
	private double seconds = 0;
	private long stamp = 0;

	public double getPreciseElapsedSeconds() {
		return ((System.currentTimeMillis() - stamp) / 1.0E03);
	}
	
	public int getRoundedElapsedSeconds() {
		return (int) (Math.round((System.currentTimeMillis() - stamp) / 1.0E03));
	}

	public void setDelay(double seconds) {
		this.seconds = seconds;
	}

	public long getStamp() {
		return stamp;
	}

	public void setStamp() {
		stamp = System.currentTimeMillis();
	}
	
	public boolean expired() {
		return getPreciseElapsedSeconds() >= seconds;
	}
	
	public double getPreciseReverse() {
		return (seconds - getPreciseElapsedSeconds());
	}
	
	public int getRoundedReverse() {
		return (int) Math.round((seconds - getPreciseElapsedSeconds()));
	}
	
	public MillisTimer(double s) {
		setDelay(s);
		setStamp();
	}
	
	public MillisTimer() {}
	
	public void start(double s) {
		setDelay(s);
		setStamp();
	}

}
